!
subroutine DF12(Y, H, DY, Error)
!      Y(X)
!    X1 ... XN   .
real, intent(in):: Y(:), H
real:: DY(:)
integer:: Error
real:: H2
integer:: i, n
!begin
  n=size(Y)
  if(n<3 .or. H==0.0) then
    Error=65; return
  end if
  H2=2.0*H
  DY(1)=(-3.0*Y(1)+4.0*Y(2)-Y(3))/H2
  do i=2, n-1
    DY(i)=(Y(i+1)-Y(i-1))/H2
  end do
  DY(n)=(Y(n-2)-4.0*Y(n-1)+3.0*Y(n))/H2
  Error=0
  return
end subroutine DF12
